/***************************************************************************
 *                                                                         *
 *   Copyright ©2020 KylinSec. All rights reserved.                      *
 *                                                                         *
 ***************************************************************************/
#ifndef KYLINSECSECURITYCENTERDBUS_H
#define KYLINSECSECURITYCENTERDBUS_H

#include "kylinsec-security-center-dbus_global.h"
#include <QObject>

class KYLINSECSECURITYCENTERDBUSSHARED_EXPORT KylinsecSecurityCenterDbus : public QObject
{
    Q_OBJECT
public:
    explicit KylinsecSecurityCenterDbus(QObject *parent = nullptr);

    Q_PROPERTY(QString getLoginFailedOpr READ getLoginFailedOpr)
    Q_PROPERTY(bool getPasswordComplex READ getPasswordComplex)
    Q_PROPERTY(int getPasswordExpired READ getPasswordExpired)
    Q_PROPERTY(QString getSelinuxConfig READ getSelinuxConfig)
    Q_PROPERTY(int getSessionTimeout READ getSessionTimeout)
    Q_PROPERTY(int getAuthType READ getAuthType)
    QString getLoginFailedOpr();
    bool getPasswordComplex();
    int getPasswordExpired();
    QString getSelinuxConfig();
    int getSessionTimeout();
    int getAuthType();//

signals:

public slots:
    //登录失败时的处理
    int setLoginFailedOpr(int failCount, int lockTime);
    //密码复杂度
    int setPasswordComplex(bool enabled);
    //密码过期时间
    int setPasswordExpired(int days);
    //selinux策略
    int setSelinuxConfig(QString config);
    //会话超时时间
    int setSessionTimeout(int seconds);
    //认证方式
    int setAuthType(int type);//

private:
    bool copyFile(const QString &sourceFile, const QString &targetFile);

private:
    int setSettingsValue(const QString &configFile, const QString &regexp, const QString &replaceStr, const QString &groupName=QString(), const QString&insertRowRegexp=QString(), const bool &insertNextRow=false);
    QStringList getSettingsValue(const QString &configFile, const QString &regexp);
    int isSpecial();

    int GetSpecialTag;
};

#endif // KYLINSECSECURITYCENTERDBUS_H
